
#if (__VERSION__ > 120)
in vec2 pass_uv;
out vec4 fragmentColor;
#else
varying vec2 pass_uv;
#endif

uniform sampler2D tex;
uniform float exposure;

void main() {
	vec4 color = texture2D(tex, pass_uv);
#if (__VERSION__ > 120)
	fragmentColor = vec4(color.rgb * pow(2.0, exposure), color.a);
#else
	gl_FragColor = vec4(color.rgb * pow(2.0, exposure), color.a);
#endif
}
