
#if (__VERSION__ > 120)
	in vec2 pass_uv;
	out vec4 frag_color;
#else
	varying vec2 pass_uv;
#endif

uniform sampler2D tex;
uniform float gamma;

void main() {
	vec4 color = texture2D(tex, pass_uv);

#if (__VERSION__ > 120)	
	frag_color = vec4(pow(color.rgb, vec3(1.0 / gamma)), color.a);
#else
	gl_FragColor = vec4(pow(color.rgb, vec3(1.0 / gamma)), color.a);
#endif

}
