
// https ://learnopengl.com/Advanced-Lighting/Bloom
// vertical gaussian blur

#if (__VERSION__ > 120)
in vec2 pass_uv;
out vec4 fragmentColor;
#else
varying vec2 pass_uv;
#endif

uniform sampler2D tex;
uniform float tex_size;

// version 100 es에서 array initialize를 지원하지 않음.
//float offset[3] = float[](0.0, 1.3846153846, 3.2307692308);
//float weight[3] = float[](0.2270270270, 0.3162162162, 0.0702702703);

void main() {
	float offset[3], weight[3];
	offset[0] = 0.0; offset[1] = 1.3846153846; offset[2] = 3.2307692308;
	weight[0] = 0.2270270270; weight[1] = 0.3162162162; weight[2] = 0.0702702703;

	vec3 color = texture2D(tex, pass_uv).rgb * weight[0];

	for (int i = 1; i < 3; i++) {
		color += texture2D(tex, pass_uv + vec2(0.0, offset[i]) / tex_size).rgb * weight[i];
		color += texture2D(tex, pass_uv - vec2(0.0, offset[i]) / tex_size).rgb * weight[i];
	}
#if (__VERSION__ > 120)
	fragmentColor = vec4(color, 1.0);
#else
	gl_FragColor = vec4(color, 1.0);
#endif
}
