
#if (__VERSION__ > 120)
in vec2 pass_uv;
out vec4 fragmentColor;
#else
varying vec2 pass_uv;
#endif

uniform sampler2D tex;

void main() {
	vec4 color = texture2D(tex, pass_uv);
	float c = 1.0 - (1.0 - color.g) * (1.0 - color.b) * 2.0;
	if (color.g < 0.5) c = 2.0 * color.g * color.b;

#if (__VERSION__ > 120)
	fragmentColor = vec4(c, c, c, color.a);
#else
	gl_FragColor = vec4(c, c, c, color.a);
#endif
}
