
#if (__VERSION__ > 120)
in vec2 pass_uv;
out vec4 frag_color;
#else
varying vec2 pass_uv;
#endif

uniform sampler2D tex0;
uniform sampler2D tex1;

void main() {
	float hard_light = texture2D(tex0, pass_uv).r - texture2D(tex1, pass_uv).r + 0.5;
	for (int i = 0; i < 3; i++) {
		if (hard_light < 0.5) hard_light = hard_light * hard_light * 2.0;
		else hard_light = 1.0 - (1.0 - hard_light) * (1.0 - hard_light) * 2.0;
	}
	float k = 255.0 / (164.0 - 75.0);
	hard_light = (hard_light - 75.0 / 255.0) * k;
	hard_light = clamp(hard_light, 0.0, 1.0);

#if (__VERSION__ > 120)
	frag_color = vec4(hard_light, hard_light, hard_light, 1.0);
#else
	gl_FragColor = vec4(hard_light, hard_light, hard_light, 1.0);
#endif

}
