
#if (__VERSION__ > 120)
in vec2 pass_uv;
out vec4 frag_color;
#else
varying vec2 pass_uv;
#endif

uniform sampler2D tex;
uniform sampler2D mask_tex;
uniform sampler2D lut;

void main() {
	vec3 color = texture2D(tex, pass_uv).rgb;
	vec3 curve_color;

	// color cuve fitting
	curve_color.r = texture2D(lut, vec2(color.r, 0)).a;
	curve_color.g = texture2D(lut, vec2(color.g, 0)).a;
	curve_color.b = texture2D(lut, vec2(color.b, 0)).a;

	// blending by mask
	float a = texture2D(mask_tex, pass_uv).r;

#if (__VERSION__ > 120)
	frag_color = vec4(a * color + (1.0 - a) * curve_color, 1.0);
#else
	gl_FragColor = vec4(a * color + (1.0 - a) * curve_color, 1.0);
#endif
}
