// BEAUTIFY_HEALTHY RGB_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
#define BEAUTIFY 1

const vec2 singleStepOffset = vec2(2.0 / (3.000 * 360.000), 2.0 / (3.000 * 640.000));
const vec2 singleStepOffset0 = singleStepOffset * vec2(0.0, -10.0);
const vec2 singleStepOffset1 = singleStepOffset * vec2(0.0, 10.0);
const vec2 singleStepOffset2 = singleStepOffset * vec2(-10.0, 0.0);
const vec2 singleStepOffset3 = singleStepOffset * vec2(10.0, 0.0);
const vec2 singleStepOffset4 = singleStepOffset * vec2(5.0, -8.0);
const vec2 singleStepOffset5 = singleStepOffset * vec2(5.0, 8.0);
const vec2 singleStepOffset6 = singleStepOffset * vec2(-5.0, 8.0);
const vec2 singleStepOffset7 = singleStepOffset * vec2(-5.0, -8.0);
const vec2 singleStepOffset8 = singleStepOffset * vec2(8.0, -5.0);
const vec2 singleStepOffset9 = singleStepOffset * vec2(8.0, 5.0);
const vec2 singleStepOffset10 = singleStepOffset * vec2(-8.0, 5.0);
const vec2 singleStepOffset11 = singleStepOffset * vec2(-8.0, -5.0);
const vec2 singleStepOffset12 = singleStepOffset * vec2(0.0, -6.0);
const vec2 singleStepOffset13 = singleStepOffset * vec2(0.0, 6.0);
const vec2 singleStepOffset14 = singleStepOffset * vec2(6.0, 0.0);
const vec2 singleStepOffset15 = singleStepOffset * vec2(-6.0, 0.0);
const vec2 singleStepOffset16 = singleStepOffset * vec2(-4.0, -4.0);
const vec2 singleStepOffset17 = singleStepOffset * vec2(-4.0, 4.0);
const vec2 singleStepOffset18 = singleStepOffset * vec2(4.0, -4.0);
const vec2 singleStepOffset19 = singleStepOffset * vec2(4.0, 4.0);

const float params = 0.33;
const highp vec3 W = vec3(0.299,0.587,0.114);
vec2 blurCoordinates[20];

float hardLight(float color)
{
	if(color <= 0.5)
		color = color * color * 2.0;
	else
		color = 1.0 - ((1.0 - color)*(1.0 - color) * 2.0);
	return color;
}

// healthy
uniform sampler2D texture_filter1;	// curve
uniform sampler2D texture_filter2;	// mask

vec4 level0c(vec4 color, sampler2D sampler) 
{ 
	color.r = texture2D(sampler, vec2(color.r, 0.)).r; 
	color.g = texture2D(sampler, vec2(color.g, 0.)).r;
	color.b = texture2D(sampler, vec2(color.b, 0.)).r;
	return color;
} 

vec4 level1c(vec4 color, sampler2D sampler) 
{ 
	color.r = texture2D(sampler, vec2(color.r, 0.)).g;
	color.g = texture2D(sampler, vec2(color.g, 0.)).g;
	color.b = texture2D(sampler, vec2(color.b, 0.)).g;
	return color;
} 

vec4 level2c(vec4 color, sampler2D sampler) 
{ 
	color.r = texture2D(sampler, vec2(color.r,0.)).b; 
	color.g = texture2D(sampler, vec2(color.g,0.)).b;
	color.b = texture2D(sampler, vec2(color.b,0.)).b; 
	return color; 
} 

vec3 rgb2hsv(vec3 c) 
{
	vec4 K = vec4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0); 
	vec4 p = mix(vec4(c.bg, K.wz), vec4(c.gb, K.xy), step(c.b, c.g)); 
	vec4 q = mix(vec4(p.xyw, c.r), vec4(c.r, p.yzx), step(p.x, c.r)); 
	
	float d = q.x - min(q.w, q.y); 
	float e = 1.0e-10; 

	// by jhh
#if 1
	if((6.0 * d + e) == 0.0 && (q.x + e) == 0.0) {
		return vec3(1, 1, q.x); 
	} else if((6.0 * d + e) == 0.0) {
		return vec3(1, d / (q.x + e), q.x); 
	} else if((q.x + e) == 0.0) {
		return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), 1, q.x); 
	} else {
		return vec3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x); 
	}
#endif
} 

vec3 hsv2rgb(vec3 c) 
{ 
	vec4 K = vec4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0); 
	vec3 p = abs(fract(c.xxx + K.xyz) * 6.0 - K.www); 
	return c.z * mix(K.xxx, clamp(p - K.xxx, 0.0, 1.0), c.y); 
}

vec4 normal(vec4 c1, vec4 c2, float alpha) 
{ 
	return (c2-c1) * alpha + c1; 
} 

vec4 multiply(vec4 c1, vec4 c2) 
{
	return c1 * c2 * 1.01;
}

vec4 overlay(vec4 c1, vec4 c2)
{
	vec4 color = vec4(0.,0.,0.,1.);
	
	color.r = c1.r < 0.5 ? 2.0*c1.r*c2.r : 1.0 - 2.0*(1.0-c1.r)*(1.0-c2.r);
	color.g = c1.g < 0.5 ? 2.0*c1.g*c2.g : 1.0 - 2.0*(1.0-c1.g)*(1.0-c2.g);
	color.b = c1.b < 0.5 ? 2.0*c1.b*c2.b : 1.0 - 2.0*(1.0-c1.b)*(1.0-c2.b); 

	return color;
}

vec4 screen(vec4 c1, vec4 c2) 
{ 
	return vec4(1.) - ((vec4(1.) - c1) * (vec4(1.) - c2)); 
}
//ENDDEF

void main() {
    gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
    if (BEAUTIFY == 1) {
		//vec3 centralColor = texture2D(inputImageTexture, textureCoordinate).rgb;
		vec3 centralColor = gl_FragColor.rgb;

		blurCoordinates[0] = interp_tc.xy + singleStepOffset0;
		blurCoordinates[1] = interp_tc.xy + singleStepOffset1;
		blurCoordinates[2] = interp_tc.xy + singleStepOffset2;
		blurCoordinates[3] = interp_tc.xy + singleStepOffset3;
		blurCoordinates[4] = interp_tc.xy + singleStepOffset4;
		blurCoordinates[5] = interp_tc.xy + singleStepOffset5;
		blurCoordinates[6] = interp_tc.xy + singleStepOffset6;
		blurCoordinates[7] = interp_tc.xy + singleStepOffset7;
		blurCoordinates[8] = interp_tc.xy + singleStepOffset8;
		blurCoordinates[9] = interp_tc.xy + singleStepOffset9;
		blurCoordinates[10] = interp_tc.xy + singleStepOffset10;
		blurCoordinates[11] = interp_tc.xy + singleStepOffset11;
		blurCoordinates[12] = interp_tc.xy + singleStepOffset12;
		blurCoordinates[13] = interp_tc.xy + singleStepOffset13;
		blurCoordinates[14] = interp_tc.xy + singleStepOffset14;
		blurCoordinates[15] = interp_tc.xy + singleStepOffset15;
		blurCoordinates[16] = interp_tc.xy + singleStepOffset16;
		blurCoordinates[17] = interp_tc.xy + singleStepOffset17;
		blurCoordinates[18] = interp_tc.xy + singleStepOffset18;
		blurCoordinates[19] = interp_tc.xy + singleStepOffset19;

		float sampleColor = centralColor.g * 20.0;
		sampleColor += texture2D(rgb_tex, blurCoordinates[0]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[1]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[2]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[3]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[4]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[5]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[6]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[7]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[8]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[9]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[10]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[11]).g;
		sampleColor += texture2D(rgb_tex, blurCoordinates[12]).g * 2.0;
		sampleColor += texture2D(rgb_tex, blurCoordinates[13]).g * 2.0;
		sampleColor += texture2D(rgb_tex, blurCoordinates[14]).g * 2.0;
		sampleColor += texture2D(rgb_tex, blurCoordinates[15]).g * 2.0;
		sampleColor += texture2D(rgb_tex, blurCoordinates[16]).g * 2.0;
		sampleColor += texture2D(rgb_tex, blurCoordinates[17]).g * 2.0;
		sampleColor += texture2D(rgb_tex, blurCoordinates[18]).g * 2.0;
		sampleColor += texture2D(rgb_tex, blurCoordinates[19]).g * 2.0;

		sampleColor = sampleColor / 48.0;

		float highPass = centralColor.g - sampleColor + 0.5;

		for(int i = 0; i < 5;i++)
		{
			highPass = hardLight(highPass);
		}
		float luminance = dot(centralColor, W);
		float alpha = pow(luminance, params);

		vec3 smoothColor = centralColor + (centralColor-vec3(highPass))*alpha*0.1;
		gl_FragColor = vec4(mix(smoothColor.rgb, max(smoothColor, centralColor), alpha), 1.0);
	}

    // yuv_healthy_filter.glsl	
	// healthy 
   	vec4 t0 = texture2D(texture_filter2, vec2(interp_tc.x, interp_tc.y)); 

	highp vec3 hsv = rgb2hsv(gl_FragColor.rgb); 
	lowp float h = hsv.x; 
	lowp float s = hsv.y; 
	lowp float v2 = hsv.z; 
	
	lowp float cF = 0.;   
	// color strength 
	lowp float cG = 0.;   
	// color gap; 
	lowp float sF = 0.06; 
	// saturation strength; 
	
	if(h >= 0.125 && h <= 0.208) 
	{ 
		// 45 to 75 
		s = s - (s * sF); 
	} 
	else if (h >= 0.208 && h < 0.292) 
	{ 
		// 75 to 105 
		cG = abs(h - 0.208); 
		cF = (cG / 0.0833); 
		s = s - (s * sF * cF); 
	} 
	else if (h > 0.042 && h <=  0.125) 
	{ 
		// 15 to 45 
		cG = abs(h - 0.125); 
		cF = (cG / 0.0833); 
		s = s - (s * sF * cF); 
	} 
	hsv.y = s; 
	
	highp vec4 c6 = vec4(hsv2rgb(hsv),1.); 
	
	c6 = normal(c6, screen  (c6, c6), 0.275); // screen 70./255. 
	c6 = normal(c6, overlay (c6, vec4(1., 0.61176, 0.25098, 1.)), 0.04); // overlay 10./255. 
	c6 = normal(c6, multiply(c6, t0), 0.262); // multiply 67./255. 
	c6 = level1c(level0c(c6,texture_filter1),texture_filter1); 
	
	gl_FragColor = c6;
    //ENDCODE
}
