// BEAUTIFY_ROMANCE RGB_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
#define BEAUTIFY 1

const vec2 singleStepOffset = vec2(2.0 / (3.000 * 360.000), 2.0 / (3.000 * 640.000));
const vec2 singleStepOffset0 = singleStepOffset * vec2(0.0, -10.0);
const vec2 singleStepOffset1 = singleStepOffset * vec2(0.0, 10.0);
const vec2 singleStepOffset2 = singleStepOffset * vec2(-10.0, 0.0);
const vec2 singleStepOffset3 = singleStepOffset * vec2(10.0, 0.0);
const vec2 singleStepOffset4 = singleStepOffset * vec2(5.0, -8.0);
const vec2 singleStepOffset5 = singleStepOffset * vec2(5.0, 8.0);
const vec2 singleStepOffset6 = singleStepOffset * vec2(-5.0, 8.0);
const vec2 singleStepOffset7 = singleStepOffset * vec2(-5.0, -8.0);
const vec2 singleStepOffset8 = singleStepOffset * vec2(8.0, -5.0);
const vec2 singleStepOffset9 = singleStepOffset * vec2(8.0, 5.0);
const vec2 singleStepOffset10 = singleStepOffset * vec2(-8.0, 5.0);
const vec2 singleStepOffset11 = singleStepOffset * vec2(-8.0, -5.0);
const vec2 singleStepOffset12 = singleStepOffset * vec2(0.0, -6.0);
const vec2 singleStepOffset13 = singleStepOffset * vec2(0.0, 6.0);
const vec2 singleStepOffset14 = singleStepOffset * vec2(6.0, 0.0);
const vec2 singleStepOffset15 = singleStepOffset * vec2(-6.0, 0.0);
const vec2 singleStepOffset16 = singleStepOffset * vec2(-4.0, -4.0);
const vec2 singleStepOffset17 = singleStepOffset * vec2(-4.0, 4.0);
const vec2 singleStepOffset18 = singleStepOffset * vec2(4.0, -4.0);
const vec2 singleStepOffset19 = singleStepOffset * vec2(4.0, 4.0);

const float params = 0.33;
const highp vec3 W = vec3(0.299,0.587,0.114);
vec2 blurCoordinates[20];

float hardLight(float color)
{
	if(color <= 0.5)
		color = color * color * 2.0;
	else
		color = 1.0 - ((1.0 - color)*(1.0 - color) * 2.0);
	return color;
}

// romance
uniform sampler2D texture_filter1;	// curve

//ENDDEF

void main() {
    gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
    if (BEAUTIFY == 1) {
        //vec3 centralColor = texture2D(inputImageTexture, textureCoordinate).rgb;
        vec3 centralColor = gl_FragColor.rgb;

        blurCoordinates[0] = interp_tc.xy + singleStepOffset0;
        blurCoordinates[1] = interp_tc.xy + singleStepOffset1;
        blurCoordinates[2] = interp_tc.xy + singleStepOffset2;
        blurCoordinates[3] = interp_tc.xy + singleStepOffset3;
        blurCoordinates[4] = interp_tc.xy + singleStepOffset4;
        blurCoordinates[5] = interp_tc.xy + singleStepOffset5;
        blurCoordinates[6] = interp_tc.xy + singleStepOffset6;
        blurCoordinates[7] = interp_tc.xy + singleStepOffset7;
        blurCoordinates[8] = interp_tc.xy + singleStepOffset8;
        blurCoordinates[9] = interp_tc.xy + singleStepOffset9;
        blurCoordinates[10] = interp_tc.xy + singleStepOffset10;
        blurCoordinates[11] = interp_tc.xy + singleStepOffset11;
        blurCoordinates[12] = interp_tc.xy + singleStepOffset12;
        blurCoordinates[13] = interp_tc.xy + singleStepOffset13;
        blurCoordinates[14] = interp_tc.xy + singleStepOffset14;
        blurCoordinates[15] = interp_tc.xy + singleStepOffset15;
        blurCoordinates[16] = interp_tc.xy + singleStepOffset16;
        blurCoordinates[17] = interp_tc.xy + singleStepOffset17;
        blurCoordinates[18] = interp_tc.xy + singleStepOffset18;
        blurCoordinates[19] = interp_tc.xy + singleStepOffset19;

        float sampleColor = centralColor.g * 20.0;
        sampleColor += texture2D(rgb_tex, blurCoordinates[0]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[1]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[2]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[3]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[4]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[5]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[6]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[7]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[8]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[9]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[10]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[11]).g;
        sampleColor += texture2D(rgb_tex, blurCoordinates[12]).g * 2.0;
        sampleColor += texture2D(rgb_tex, blurCoordinates[13]).g * 2.0;
        sampleColor += texture2D(rgb_tex, blurCoordinates[14]).g * 2.0;
        sampleColor += texture2D(rgb_tex, blurCoordinates[15]).g * 2.0;
        sampleColor += texture2D(rgb_tex, blurCoordinates[16]).g * 2.0;
        sampleColor += texture2D(rgb_tex, blurCoordinates[17]).g * 2.0;
        sampleColor += texture2D(rgb_tex, blurCoordinates[18]).g * 2.0;
        sampleColor += texture2D(rgb_tex, blurCoordinates[19]).g * 2.0;

        sampleColor = sampleColor / 48.0;

        float highPass = centralColor.g - sampleColor + 0.5;

        for(int i = 0; i < 5;i++)
        {
            highPass = hardLight(highPass);
        }
        float luminance = dot(centralColor, W);
        float alpha = pow(luminance, params);

        vec3 smoothColor = centralColor + (centralColor-vec3(highPass))*alpha*0.1;
        gl_FragColor = vec4(mix(smoothColor.rgb, max(smoothColor, centralColor), alpha), 1.0);
    }

	// romance 
	lowp vec4 textureColor;
	lowp vec4 textureColorRes; 
	lowp vec4 textureColorOri; 
	vec4 grey1Color; 
	vec4 layerColor; 
	mediump float satVal = 115.0 / 100.0; 

    float xCoordinate = interp_tc.x;
	float yCoordinate = interp_tc.y; 
	
	highp float redCurveValue; 
	highp float greenCurveValue; 
	highp float blueCurveValue; 

	textureColor = gl_FragColor;
    textureColorRes = textureColor; 
	textureColorOri = textureColor; 

	// step1. screen blending 
	textureColor = 1.0 - ((1.0 - textureColorOri) * (1.0 - textureColorOri)); 
	textureColor = (textureColor - textureColorOri) + textureColorOri; 

	// step2. curve 
	redCurveValue = texture2D(texture_filter1, vec2(textureColor.r, 0.0)).r; 
	greenCurveValue = texture2D(texture_filter1, vec2(textureColor.g, 0.0)).g; 
    blueCurveValue = texture2D(texture_filter1, vec2(textureColor.b, 0.0)).b; 

	// step3. saturation 
	highp float G = (redCurveValue + greenCurveValue + blueCurveValue); 
	G = G / 3.0; 

    redCurveValue = ((1.0 - satVal) * G + satVal * redCurveValue); 
	greenCurveValue = ((1.0 - satVal) * G + satVal * greenCurveValue); 
	blueCurveValue = ((1.0 - satVal) * G + satVal * blueCurveValue); 

	textureColor = vec4(redCurveValue, greenCurveValue, blueCurveValue, 1.0); 

    gl_FragColor = vec4(textureColor.r, textureColor.g, textureColor.b, 1.0);
    //ENDCODE
}
