// BLURBOX RGB_FRAGMENT_SHADER_STRING
// https://goo.gl/RVixgx 
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
#define THRESHOLD 0.02
#define GRANULARITY 2
#define STEPS (GRANULARITY * 2 + 1)
//ENDDEF

void main() {
    gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
    //vec2 uv = fragCoord.xy / iResolution.xy;
    //vec4 origin = texture2D(rgb_tex, uv);
    vec2 uv = interp_tc;
    vec4 origin = gl_FragColor;

    float scope = THRESHOLD * float(GRANULARITY);
    vec4 result = vec4(0, 0, 0, origin.w);
    int total = 0;
    for (int i = 0; i < STEPS; ++i) {
        for (int j = 0; j < STEPS; ++j) {
        	float x = uv.x - scope + THRESHOLD * float(i);
            float y = uv.y - scope + THRESHOLD * float(j);
            vec4 col = texture2D(rgb_tex, vec2(x, y));
            if (x < 0.0 || x > 1.0 || y < 0.0 || y > 1.0) continue;
            result.x += col.x;
            result.y += col.y;
            result.z += col.z;
            ++total;
        }
    }
    result.x = result.x / float(total);
    result.y = result.y / float(total);
    result.z = result.z / float(total);
    gl_FragColor = result;
    //ENDCODE
}
