// BLURCONV RGB_FRAGMENT_SHADER_STRING
// https://goo.gl/tz3SnZ 
precision highp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
const float conNum = 9.0;
#ifdef WEBGL_THREEJS
const vec2 conPixel = vec2(conNum/460.000, conNum/512.000);
#else
const vec2 conPixel = vec2(conNum/640.00, conNum/480.00);
#endif

//const float conMatrix[9] = [1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  1.0, 1.0, 1.0];
const float conMatval = 1.0;    // Matrix -> Single value로 바꿈 밝기에 영향
const float conWeight = 1.0 / 9.0;
//ENDDEF

void main() {
    gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
    vec4 color = vec4(0.0);
    vec2 texCoord = interp_tc.st;
    vec2 offset = conPixel * 1.5;
    vec2 start = texCoord - offset;
    vec2 current = start;

    for (int i = 0; i < 9; i++)
    {
        color += texture2D( rgb_tex, current ) * conMatval; // conMatrix[i]; 

        current.x += conPixel.x;
        if (i == 2 || i == 5) {
            current.x = start.x;
            current.y += conPixel.y; 
        }
    }

    gl_FragColor = color * conWeight;
    //ENDCODE
}
