// BLURGUAS RGB_FRAGMENT_SHADER_STRING
precision highp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
const highp float blurSize = 7.0;
const int steps = 4;   // 4.8999999999999995 int(min(radius * 0.7, sqrt(radius) * pi));
const float bloom = 1.0;
const float texelWidthOffset = 1.0 / 360.000;
const float texelHeightOffset = 1.0 / 640.000;
//ENDDEF

void main() {
    gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
    float v;
    float pi = 3.141592653589793;
    float radius = blurSize;
    if ( radius < 0.0 ) radius = 0.0;
    //int steps = int(min(radius * 0.7, sqrt(radius) * pi));
    float r = radius / float(steps);
    float t = bloom / float(steps * 2 + 1);
    float x = interp_tc.x;
    float y = interp_tc.y;
    vec4 sum = texture2D(rgb_tex, vec2(x, y)) * t;
    //int i;
    for(int i = 1; i <= steps; i++){
        v = (cos(float(i) / float(steps + 1) / pi) + 1.0) * 0.5;
        sum += texture2D(rgb_tex, vec2(x + float(i) * texelWidthOffset * r, y + float(i) * texelHeightOffset * r)) * v * t;
        sum += texture2D(rgb_tex, vec2(x - float(i) * texelWidthOffset * r, y - float(i) * texelHeightOffset * r)) * v * t;
    }
    
    gl_FragColor = sum;
    //ENDCODE
}
