// RGB_FRAGMENT_SHADER_STRING BLURMIPMAP
// MIPMAP 이용해서 BLUR 효과를 주는 방식. https://www.learnopengles.com/tag/mipmap/
// https://www.shadertoy.com/view/WsVGWV
// Weighted integration over mipmap levels
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
#define PI 3.14159265
#define BLURRADIUS 75
//ENDDEF

void main() {
    //STARTCODE
    //vec2 uv = pos/iResolution.xy;
    vec2 uv = interp_tc;
    
    //float blur_radius =1.+ 50.*(0.5*sin(1.8*iTime+0.000*pos.x) + 0.5);
    float gamma = 0.5;
    float radius = float(BLURRADIUS);

    float norm = 0.0;
    vec3 pix = vec3(0.0, 0.0, 0.0);

    // weighted integration over mipmap levels
    for(float i = 0.0; i < 10.; i += 0.5)
    {
        float k = exp(-gamma * pow(log2(radius) - i, 2.0));
        pix += k * texture2D(rgb_tex, vec2(uv.x, uv.y), i).xyz;
        norm += k;
    }
    //gl_FragColor = vec4( pix, 1.0 );
    gl_FragColor = vec4(pix * pow(norm, -0.95), 1.0);

    //ENDCODE
}
