// CRAYON RGB_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
#ifdef WEBGL_THREEJS_DETAIL
uniform vec2 stepoffset;
uniform float strength;
#else
const vec2  stepoffset = vec2(1.0/360.000, 1.0/640.000);
const float strength = 1.0; // 2.0;	// 0.5;
#endif

const highp vec3 W = vec3(0.299,0.587,0.114);

const mat3 rgb2yiqMatrix = mat3(
		0.299, 0.587, 0.114,
		0.596,-0.275,-0.321,
		0.212,-0.523, 0.311);

const mat3 yiq2rgbMatrix = mat3(
		1.0, 0.956, 0.621,
		1.0,-0.272,-1.703,
		1.0,-1.106, 0.0);
//ENDDEF

void main() {
	gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
	//vec4 oralColor = texture2D(inputImageTexture, textureCoordinate);
	vec4 oralColor = gl_FragColor;

	vec3 maxValue = vec3(0.,0.,0.);
	
	for(int i = -2; i<=2; i++)
	{
		for(int j = -2; j<=2; j++)
		{
			//vec4 tempColor = texture2D(inputImageTexture, textureCoordinate+singleStepOffset*vec2(i,j));
			vec4 tempColor = texture2D(rgb_tex, interp_tc + stepoffset*vec2(i,j));

			maxValue.r = max(maxValue.r,tempColor.r);
			maxValue.g = max(maxValue.g,tempColor.g);
			maxValue.b = max(maxValue.b,tempColor.b);
		}
	}
	
	// by jhh
	// rgb를 각각 확인하도록 하니까 red나green 같이 특정 값이 너무 높게 나오는 부분이 있어서,
	// rgb중 하나가 0일 경우 결과가 흰색으로 나오도록 수정함.
#if 0
	vec3 textureColor = vec3(1.0, 1.0 ,1.0);
	if(maxValue.r != 0.0) {
		textureColor.r = oralColor.r / maxValue.r;
	}

	if(maxValue.g != 0.0) {
		textureColor.g = oralColor.g / maxValue.g;
	}
	
	if(maxValue.b != 0.0) {
		textureColor.b = oralColor.b / maxValue.b;
	}
#else
	vec3 textureColor = vec3(1.0, 1.0 ,1.0);
	if(maxValue.r != 0.0 && maxValue.g != 0.0 && maxValue.b != 0.0) {
		textureColor = oralColor.rgb / maxValue;
	}
#endif
	
	float gray = dot(textureColor, W);
	float k = 0.223529;
	float alpha = min(gray,k)/k;
	
	textureColor = textureColor * alpha + (1.-alpha)*oralColor.rgb;
	
	vec3 yiqColor = textureColor * rgb2yiqMatrix;

	yiqColor.r = max(0.0,min(1.0,pow(gray,strength)));

	textureColor = yiqColor * yiq2rgbMatrix;
	
	gl_FragColor = vec4(textureColor, oralColor.w);
    //ENDCODE    
}
