// FISHEYE RGB_FRAGMENT_SHADER_STRING
precision highp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
const float BarrelPower = 1.4;
const float PI = 3.1415926535;

vec2 Distort(vec2 p)
{
    float theta  = atan(p.y, p.x);
    float radius = length(p);
    radius = pow(radius, BarrelPower);
    p.x = radius * cos(theta);
    p.y = radius * sin(theta);
	return 0.5 * (p + 1.0);
}
//ENDDEF

void main() {
	//gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
	vec2 xy = 2.0 * interp_tc.xy - 1.0;
	vec2 uv;
	float d = length(xy);
	if (d < 8.0)	// 1.0
	{
		uv = Distort(xy);
	}
	else
	{
		uv = interp_tc.xy;
	}
	//vec4 c = texture2D(tex0, uv);
#ifdef WEBGL_THREEJS
	vec4 c = texture2D(tDiffuse, uv);
#else
	vec4 c = texture2D(rgb_tex, uv);
#endif
	gl_FragColor = c;
	//ENDCODE    
}

