// FISHEYEANTI RGB_FRAGMENT_SHADER_STRING
precision highp float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
#ifdef WEBGL_THREEJS
const vec2 iResolution = vec2(460.000, 512.000);
#else
const vec2 iResolution = vec2(360.0000, 640.0000);
const float FRAG_BOTTOM = 0.5000;	// 158.0;
#endif
//ENDDEF

void main() {
	gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
	//normalized coords with some cheat 
#ifdef WEBGL_THREEJS
	vec2 p = gl_FragCoord.xy / iResolution.x;
	vec2 iMouse = vec2(iResolution.x * 0.4, iResolution.y * 0.4);
#else
	vec4 newCoord = gl_FragCoord;
	newCoord.y = gl_FragCoord.y - FRAG_BOTTOM;
	vec2 p = newCoord.yx / iResolution.y;
	vec2 iMouse = vec2(iResolution.x * 0.42, iResolution.y * 0.42);
#endif

	//screen proportion                                         
#ifdef WEBGL_THREEJS
	float prop = iResolution.x / iResolution.y;
#else
	float prop = iResolution.y / iResolution.x;
#endif
	//center coords
	vec2 m = vec2(0.5, 0.5 / prop);
	//vector from center to current fragment
	vec2 d = p - m;
	// distance of pixel from center
	float r = sqrt(dot(d, d)); 
	//amount of effect
#ifdef WEBGL_THREEJS
	float power = ( 2.0 * 3.141592 / (2.0 * sqrt(dot(m, m))) ) * (iMouse.x / iResolution.x - 0.5);
#else
	float power = ( 2.0 * 3.141592 / (2.0 * sqrt(dot(m, m))) ) * (iMouse.y / iResolution.y - 0.5);
#endif
	//radius of 1:1 effect
	float bind;
	if (power > 0.0) bind = sqrt(dot(m, m));//stick to corners
	else {if (prop < 1.0) bind = m.x; else bind = m.y;}//stick to borders

	//Weird formulas
	vec2 uv;
	if (power > 0.0)//fisheye
	uv = m + normalize(d) * tan(r * power) * bind / tan( bind * power);
	else if (power < 0.0)//antifisheye
	uv = m + normalize(d) * atan(r * -power * 10.0) * bind / atan(-power * bind * 10.0);
	else 
	uv = p;//no effect for power = 1.0

	// jackkykim - Dummy "Could not locate 'in_tc' in program"에러 방지 위해 interp_tc를 사용해줌
	uv = interp_tc + uv - interp_tc; 

	//Second part of cheat
	//for round effect, not elliptical
	//vec3 col = texture2D(iChannel0, vec2(uv.x, -uv.y * prop)).xyz;
#ifdef WEBGL_THREEJS
	vec3 col = texture2D(tDiffuse, vec2(uv.x, uv.y * prop)).xyz;
#else
	vec3 col = texture2D(rgb_tex, vec2(uv.x, 1.0 - uv.y * prop)).xyz;
#endif

	gl_FragColor = vec4(col, 1.0);
	//ENDCODE    
}
