// SCANLINE RGB_FRAGMENT_SHADER_STRING
precision mediump float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;

//STARTDEF
const float time = 1.0;
const int grayscale = 0;

// noise effect intensity value (0 = no effect, 1 = full effect)
const float nIntensity = 0.4;

// scanlines effect intensity value (0 = no effect, 1 = full effect)
const float sIntensity = 0.9;

// scanlines effect count value (0 = no effect, 4096 = full effect)
const float sCount = 800.0; // 2048.0;
//ENDDEF

void main() {
	gl_FragColor = texture2D(rgb_tex, interp_tc);

    //STARTCODE
    //vec4 cTextureScreen = texture2D( tDiffuse, vUv );
    vec4 cTextureScreen = gl_FragColor;

    // make some noise
	float x = interp_tc.x * interp_tc.y * time *  1000.0;
	x = mod( x, 13.0 ) * mod( x, 123.0 );
	float dx = mod( x, 0.01 );

	// add noise
	vec3 cResult = cTextureScreen.rgb + cTextureScreen.rgb * clamp( 0.1 + dx * 100.0, 0.0, 1.0 );

	// get us a sine and cosine
	vec2 sc = vec2( sin( interp_tc.y * sCount ), cos( interp_tc.y * sCount ) );

	// add scanlines
	cResult += cTextureScreen.rgb * vec3( sc.x, sc.y, sc.x ) * sIntensity;

	// interpolate between source and result by intensity
	cResult = cTextureScreen.rgb + clamp( nIntensity, 0.0,1.0 ) * ( cResult - cTextureScreen.rgb );

	// convert to grayscale if desired
	if( grayscale > 0 ) {
        cResult = vec3( cResult.r * 0.3 + cResult.g * 0.59 + cResult.b * 0.11 );
    }

	gl_FragColor =  vec4( cResult, cTextureScreen.a );
    //ENDCODE
}
