// BRANNAN YUV_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;  //process
uniform sampler2D texture_filter2;  //blowout
uniform sampler2D texture_filter3;  //contrast
uniform sampler2D texture_filter4;  //luma
uniform sampler2D texture_filter5;  //screen

mat3 saturateMatrix = mat3(
                        1.105150,
                        -0.044850,
                        -0.046000,
                        -0.088050,
                        1.061950,
                        -0.089200,
                        -0.017100,
                        -0.017100,
                        1.132900);

vec3 luma = vec3(.3, .59, .11);
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    vec3 texel = gl_FragColor.rgb;

    vec2 lookup;
    lookup.y = 0.5;
    lookup.x = texel.r;
    texel.r = texture2D(texture_filter1, lookup).r;
    lookup.x = texel.g;
    texel.g = texture2D(texture_filter1, lookup).g;
    lookup.x = texel.b;
    texel.b = texture2D(texture_filter1, lookup).b;

    texel = saturateMatrix * texel;

    vec2 tc = (2.0 * interp_tc) - 1.0;
    float d = dot(tc, tc);
    vec3 sampled;
    lookup.y = 0.5;
    lookup.x = texel.r;
    sampled.r = texture2D(texture_filter2, lookup).r;
    lookup.x = texel.g;
    sampled.g = texture2D(texture_filter2, lookup).g;
    lookup.x = texel.b;
    sampled.b = texture2D(texture_filter2, lookup).b;
    float value = smoothstep(0.0, 1.0, d);
    texel = mix(sampled, texel, value);

    lookup.x = texel.r;
    texel.r = texture2D(texture_filter3, lookup).r;
    lookup.x = texel.g;
    texel.g = texture2D(texture_filter3, lookup).g;
    lookup.x = texel.b;
    texel.b = texture2D(texture_filter3, lookup).b;

    lookup.x = dot(texel, luma);
    texel = mix(texture2D(texture_filter4, lookup).rgb, texel, .5);

    lookup.x = texel.r;
    texel.r = texture2D(texture_filter5, lookup).r;
    lookup.x = texel.g;
    texel.g = texture2D(texture_filter5, lookup).g;
    lookup.x = texel.b;
    texel.b = texture2D(texture_filter5, lookup).b;

    gl_FragColor = vec4(texel, 1.0);
    //ENDCODE
}
