// EARLYBIRD YUV_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;  //earlyBirdCurves
uniform sampler2D texture_filter2;  //earlyBirdOverlay
uniform sampler2D texture_filter3;  //vig
uniform sampler2D texture_filter4;  //earlyBirdBlowout
uniform sampler2D texture_filter5;  //earlyBirdMap

const mat3 saturate = mat3(
                        1.210300,
                        -0.089700,
                        -0.091000,
                        -0.176100,
                        1.123900,
                        -0.177400,
                        -0.034200,
                        -0.034200,
                        1.265800);
const vec3 rgbPrime = vec3(0.25098, 0.14640522, 0.0);
const vec3 desaturate = vec3(.3, .59, .11);
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    //vec3 texel = texture2D(inputImageTexture, textureCoordinate).rgb;
    vec3 texel = gl_FragColor.rgb;   
        
    vec2 lookup;    
    lookup.y = 0.5;
    
    lookup.x = texel.r;
    texel.r = texture2D(texture_filter1, lookup).r;
    
    lookup.x = texel.g;
    texel.g = texture2D(texture_filter1, lookup).g;
    
    lookup.x = texel.b;
    texel.b = texture2D(texture_filter1, lookup).b;
    
    float desaturatedColor;
    vec3 result;
    desaturatedColor = dot(desaturate, texel);
    
    
    lookup.x = desaturatedColor;
    result.r = texture2D(texture_filter2, lookup).r;
    lookup.x = desaturatedColor;
    result.g = texture2D(texture_filter2, lookup).g;
    lookup.x = desaturatedColor;
    result.b = texture2D(texture_filter2, lookup).b;
    
    texel = saturate * mix(texel, result, .5);
    
    vec2 tc = (2.0 * interp_tc) - 1.0;
    float d = dot(tc, tc);
    
    vec3 sampled;
    lookup.y = .5;
    
    /*
    lookup.x = texel.r;
    sampled.r = texture2D(texture_filter3, lookup).r;
    
    lookup.x = texel.g;
    sampled.g = texture2D(texture_filter3, lookup).g;
    
    lookup.x = texel.b;
    sampled.b = texture2D(texture_filter3, lookup).b;
    
    float value = smoothstep(0.0, 1.25, pow(d, 1.35)/1.65);
    texel = mix(texel, sampled, value);
    */
    
    //---
    
    lookup = vec2(d, texel.r);
    texel.r = texture2D(texture_filter3, lookup).r;
    lookup.y = texel.g;
    texel.g = texture2D(texture_filter3, lookup).g;
    lookup.y = texel.b;
    texel.b	= texture2D(texture_filter3, lookup).b;
    float value = smoothstep(0.0, 1.25, pow(d, 1.35)/1.65);
    
    //---
    
    lookup.x = texel.r;
    sampled.r = texture2D(texture_filter4, lookup).r;
    lookup.x = texel.g;
    sampled.g = texture2D(texture_filter4, lookup).g;
    lookup.x = texel.b;
    sampled.b = texture2D(texture_filter4, lookup).b;
    texel = mix(sampled, texel, value);
    
    
    lookup.x = texel.r;
    texel.r = texture2D(texture_filter5, lookup).r;
    lookup.x = texel.g;
    texel.g = texture2D(texture_filter5, lookup).g;
    lookup.x = texel.b;
    texel.b = texture2D(texture_filter5, lookup).b;
    
    gl_FragColor = vec4(texel, 1.0);
    //ENDCODE    
}
