// HEFE YUV_FRAGMENT_SHADER_STRING
precision mediump float;
varying vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;  //edgeBurn
uniform sampler2D texture_filter2;  //hefeMap
uniform sampler2D texture_filter3;  //hefeGradientMap
uniform sampler2D texture_filter4;  //hefeSoftLight
uniform sampler2D texture_filter5;  //hefeMetal

const float strength = 1.0;
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    vec4 originColor = gl_FragColor;
    vec3 texel = gl_FragColor.rgb;
    vec3 edge = texture2D(texture_filter1, interp_tc).rgb;
    texel = texel * edge;
    
    texel = vec3(
                 texture2D(texture_filter2, vec2(texel.r, .16666)).r,
                 texture2D(texture_filter2, vec2(texel.g, .5)).g,
                 texture2D(texture_filter2, vec2(texel.b, .83333)).b);
    
    vec3 luma = vec3(.30, .59, .11);
    vec3 gradSample = texture2D(texture_filter3, vec2(dot(luma, texel), .5)).rgb;
    vec3 final = vec3(
                      texture2D(texture_filter4, vec2(gradSample.r, texel.r)).r,
                      texture2D(texture_filter4, vec2(gradSample.g, texel.g)).g,
                      texture2D(texture_filter4, vec2(gradSample.b, texel.b)).b
                      );
    
    vec3 metal = texture2D(texture_filter5, interp_tc).rgb;
    vec3 metaled = vec3(
                        texture2D(texture_filter4, vec2(metal.r, texel.r)).r,
                        texture2D(texture_filter4, vec2(metal.g, texel.g)).g,
                        texture2D(texture_filter4, vec2(metal.b, texel.b)).b
                        );
    
    metaled.rgb = mix(originColor.rgb, metaled.rgb, strength);

    gl_FragColor = vec4(metaled, 1.0);
    //ENDCODE
}
