// KELVIN YUV_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;  // kelvinMap
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    //vec3 texel = texture2D(inputImageTexture, textureCoordinate).rgb;
    vec3 texel = gl_FragColor.rgb;

    vec2 lookup;
    lookup.y = .5;

    lookup.x = texel.r;
    texel.r = texture2D(texture_filter1, lookup).r;

    lookup.x = texel.g;
    texel.g = texture2D(texture_filter1, lookup).g;

    lookup.x = texel.b;
    texel.b = texture2D(texture_filter1, lookup).b;

    gl_FragColor = vec4(texel, 1.0);
    //ENDCODE
}
