// pixelate YUV_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
const float fractionalWidthOfPixel = 0.05;
const float aspectRatio = 640.000 / 360.000;
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);    

    //STARTCODE
    vec2 uv = interp_tc.xy;
    vec2 sampleDivisor = vec2(fractionalWidthOfPixel, fractionalWidthOfPixel / aspectRatio);
    vec2 samplePos = uv - mod(uv, sampleDivisor) + 0.5 * sampleDivisor;
        
    //gl_FragColor = texture2D(inputImageTexture, samplePos);
#ifdef WEBGL_THREEJS
    gl_FragColor = texture2D( tDiffuse, samplePos );
#else
    y = texture2D(y_tex, samplePos).r;
    u = texture2D(u_tex, samplePos).r - 0.5;
    v = texture2D(v_tex, samplePos).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);
#endif
    //ENDCODE
}
