// RISE YUV_FRAGMENT_SHADER_STRING
precision mediump float;
varying vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;  //blackboard1024
uniform sampler2D texture_filter2;  //overlayMap
uniform sampler2D texture_filter3;  //riseMap
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    vec4 texel = gl_FragColor;
    //vec4 texel = texture2D(inputImageTexture, textureCoordinate);
    vec3 bbTexel = texture2D(texture_filter1, interp_tc).rgb;

    texel.r = texture2D(texture_filter2, vec2(bbTexel.r, texel.r)).r;
    texel.g = texture2D(texture_filter2, vec2(bbTexel.g, texel.g)).g;
    texel.b = texture2D(texture_filter2, vec2(bbTexel.b, texel.b)).b;

    vec4 mapped;
    mapped.r = texture2D(texture_filter3, vec2(texel.r, .16666)).r;
    mapped.g = texture2D(texture_filter3, vec2(texel.g, .5)).g;
    mapped.b = texture2D(texture_filter3, vec2(texel.b, .83333)).b;
    mapped.a = 1.0;

    gl_FragColor = mapped;
    //ENDCODE
}
