// SEPIA YUV_FRAGMENT_SHADER_STRING
precision mediump float;
varying vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

void main() {
    // CSC according to http://www.fourcc.org/fccyvrgb.php
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    lowp float r = gl_FragColor.r;
    lowp float g = gl_FragColor.g;
    lowp float b = gl_FragColor.b;
    gl_FragColor.r = (r * 0.393) + (g * 0.769) + (b * 0.189);
    gl_FragColor.g = (r * 0.349) + (g * 0.686) + (b * 0.168);
    gl_FragColor.b = (r * 0.272) + (g * 0.534) + (b * 0.131);
    //ENDCODE
}
