// SUTRO YUV_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;  // vignetteMap
uniform sampler2D texture_filter2;  // sutroMetal
uniform sampler2D texture_filter3;  // softLight
uniform sampler2D texture_filter4;  // sutroEdgeBurn
uniform sampler2D texture_filter5;  // sutroCurves
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    //vec3 texel = texture2D(inputImageTexture, textureCoordinate).rgb;
    vec3 texel = gl_FragColor.rgb;

    vec2 tc = (2.0 * interp_tc) - 1.0;
    float d = dot(tc, tc);
    vec2 lookup = vec2(d, texel.r);
    texel.r = texture2D(texture_filter1, lookup).r;
    lookup.y = texel.g;
    texel.g = texture2D(texture_filter1, lookup).g;
    lookup.y = texel.b;
    texel.b	= texture2D(texture_filter1, lookup).b;

    vec3 rgbPrime = vec3(0.1019, 0.0, 0.0); 
    float m = dot(vec3(.3, .59, .11), texel.rgb) - 0.03058;
    texel = mix(texel, rgbPrime + m, 0.32);

    vec3 metal = texture2D(texture_filter2, interp_tc).rgb;
    texel.r = texture2D(texture_filter3, vec2(metal.r, texel.r)).r;
    texel.g = texture2D(texture_filter3, vec2(metal.g, texel.g)).g;
    texel.b = texture2D(texture_filter3, vec2(metal.b, texel.b)).b;

    texel = texel * texture2D(texture_filter4, interp_tc).rgb;

    texel.r = texture2D(texture_filter5, vec2(texel.r, .16666)).r;
    texel.g = texture2D(texture_filter5, vec2(texel.g, .5)).g;
    texel.b = texture2D(texture_filter5, vec2(texel.b, .83333)).b;

    gl_FragColor = vec4(texel, 1.0);
    //ENDCODE
}
