// TOASTER2 YUV_FRAGMENT_SHADER_STRING
precision mediump float;
varying vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;

const vec3 W = vec3(0.2125, 0.7154, 0.0721);

vec3 BrightnessContrastSaturation(vec3 color, float brt, float con, float sat)
{
	vec3 black = vec3(0., 0., 0.);
	vec3 middle = vec3(0.5, 0.5, 0.5);
	float luminance = dot(color, W);
	vec3 gray = vec3(luminance, luminance, luminance);
	
	vec3 brtColor = mix(black, color, brt);
	vec3 conColor = mix(middle, brtColor, con);
	vec3 satColor = mix(gray, conColor, sat);
	return satColor;
}

vec3 ovelayBlender(vec3 Color, vec3 myfilter){
	vec3 filter_result;
	
	//if(luminance < 0.5)
	//	filter_result = 2. * trans_filter * Color;
	//else
		filter_result = 1. - (1. - (2. *(myfilter - 0.5)))*(1. - Color);
		
	return filter_result;
}
//ENDDEF

void main()
{
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE	
	//get the pixel
	//vec2 st = v_TexCoordinate.st;
	//vec3 irgb = texture2D(u_Texture0, st).rgb;
	//vec3 myfilter = texture2D(u_Texture4, st).rgb;
    vec2 st = interp_tc.st;
    vec3 irgb = gl_FragColor.rgb;
    vec3 myfilter = texture2D(texture_filter1, interp_tc).rgb;

	//adjust the brightness/contrast/saturation
	float T_bright = 1.0;
	float T_contrast = 1.0;
	float T_saturation = 1.0;
	vec3 bcs_result = BrightnessContrastSaturation(irgb, T_bright, T_contrast, T_saturation);

	//more red
	vec3 rb_result = vec3(bcs_result.r*1.3, bcs_result.g, bcs_result.b*0.9);

	//add filter (overlay blending)
	vec3 after_filter = mix(bcs_result, ovelayBlender(bcs_result, myfilter), 0.55);

	gl_FragColor = vec4(after_filter, 1.);
    //ENDCODE	
}