// VALENCIA YUV_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;  // valenciaMap
uniform sampler2D texture_filter2;  // valenciaGradient

mat3 saturateMatrix = mat3(
                        1.1402,
                        -0.0598,
                        -0.061,
                        -0.1174,
                        1.0826,
                        -0.1186,
                        -0.0228,
                        -0.0228,
                        1.1772);

vec3 lumaCoeffs = vec3(.3, .59, .11);
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    vec3 texel = gl_FragColor.rgb;
    texel = vec3(
              texture2D(texture_filter1, vec2(texel.r, .1666666)).r,
              texture2D(texture_filter1, vec2(texel.g, .5)).g,
              texture2D(texture_filter1, vec2(texel.b, .8333333)).b
              );

    texel = saturateMatrix * texel;
    float luma = dot(lumaCoeffs, texel);
    texel = vec3(
              texture2D(texture_filter2, vec2(luma, texel.r)).r,
              texture2D(texture_filter2, vec2(luma, texel.g)).g,
              texture2D(texture_filter2, vec2(luma, texel.b)).b);

    gl_FragColor = vec4(texel, 1.0);
    //ENDCODE    
}
