// WILLOW2 YUV_FRAGMENT_SHADER_STRING
precision mediump float;
varying vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
const vec3 W = vec3(0.2125, 0.7154, 0.0721);

vec3 BrightnessContrastSaturation(vec3 color, float brt, float con, float sat)
{
	vec3 black = vec3(0., 0., 0.);
	vec3 middle = vec3(0.5, 0.5, 0.5);
	
	vec3 brtColor = mix(black, color, brt);
	vec3 conColor = mix(middle, brtColor, con);
	vec3 satColor = mix(color, conColor, sat);
	return satColor;
}
//ENDDEF

void main() 
{
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);
	
    //STARTCODE	
	//const vec3 W = vec3(0.2125, 0.1754, 0.0721);	
	//vec3 irgb = texture2D(u_Texture, v_TexCoordinate).rgb;
	vec3 irgb = gl_FragColor.rgb;

	float luminance = dot(irgb, W);
	vec3 gray = vec3(luminance, luminance, luminance);
	vec3 result = BrightnessContrastSaturation(gray, 2.5, 1.1, 1.0);

	gl_FragColor = vec4(result, 1.);
    //ENDCODE	
}
