// XHATCH YUV_FRAGMENT_SHADER_STRING
precision mediump float;
varying highp vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
const float crossx = 4.0;    // 3.0;
const float hyoffset = 5.0; // 5.0;
const float lthres1 = 1.0;  // 1.0;
const float lthres2 = 0.75; // 0.75;
const float lthres3 = 0.5;  // 0.5;
const float lthres4 = 0.3; // 0.3;
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    //float lum = length(texture2D(tDiffuse, vUv).rgb);
    float lum = length(gl_FragColor.rgb);

    gl_FragColor = vec4(1.0, 1.0, 1.0, 1.0);
    if (lum < lthres1) {
        if (mod(gl_FragCoord.x + gl_FragCoord.y, crossx) == 0.0) {
            gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
        }
    }
    if (lum < lthres2) {
        if (mod(gl_FragCoord.x - gl_FragCoord.y, crossx) == 0.0) {
            gl_FragColor = vec4(0.0, 0.0, 0.0, 0.1);
        }
    }
    if (lum < lthres3) {
        if (mod(gl_FragCoord.x + gl_FragCoord.y - hyoffset, crossx) == 0.0) {
            gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
        }
    }
    if (lum < lthres4) {
        if (mod(gl_FragCoord.x - gl_FragCoord.y - hyoffset, crossx) == 0.0) {
            gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
        }
    }
    //ENDCODE
}
