// XPROII YUV_FRAGMENT_SHADER_STRING
precision lowp float;
varying highp vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;

//STARTDEF
uniform sampler2D texture_filter1;  //map
uniform sampler2D texture_filter2;  //vigMap
//ENDDEF

void main() {
    float y = texture2D(y_tex, interp_tc).r;
    float u = texture2D(u_tex, interp_tc).r - 0.5;
    float v = texture2D(v_tex, interp_tc).r - 0.5;
    gl_FragColor = vec4(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u, 1);

    //STARTCODE
    vec3 texel = gl_FragColor.rgb;

    vec2 tc = (2.0 * interp_tc) - 1.0;
    float d = dot(tc, tc);
    vec2 lookup = vec2(d, texel.r);
    texel.r = texture2D(texture_filter2, lookup).r;
    lookup.y = texel.g;
    texel.g = texture2D(texture_filter2, lookup).g;
    lookup.y = texel.b;
    texel.b	= texture2D(texture_filter2, lookup).b;

    vec2 red = vec2(texel.r, 0.16666);
    vec2 green = vec2(texel.g, 0.5);
    vec2 blue = vec2(texel.b, .83333);
    texel.r = texture2D(texture_filter1, red).r;
    texel.g = texture2D(texture_filter1, green).g;
    texel.b = texture2D(texture_filter1, blue).b;

    gl_FragColor = vec4(texel, 1.0);
    //ENDCODE    
}
